// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* \li ̧			: OWIIntFunctions.c
* \li ߲		: IAR EWAAVR 3.20a
* \li xҰ		: avr@atmel.com
*
* \li x޲	: UART܂USARTSĂAVR
*
* \li pLq		: AVR318 - Dallas 1-Wire(R)呕u
*
* \li 			: 0`255ޯĂ̎M
*					  ֐Ɗ荞ݏٰ
*
*                         $Revision: 1.7 $
*                         $Date: Thursday, August 19, 2004 14:27:18 UTC $
****************************************************************************/

#include "OWIIntFunctions.h"
#include <ioavr.h>
#include "OWIInterruptDriven.h"

OWIflags OWIStatus;
unsigned char *OWIDataBuffer;
unsigned char OWIBufferLength;


/*! \brief 1-WireʐMpU(S)ART
 *
 * ̊֐1-WireʐMpU(S)ART`Ԑݒ肵܂B
 *
 *  \note	Ұ"OWIInterruptDriven.h"Őݒ肳܂B
 */
void OWI_Init(void)
{
  OWI_UART_STATCTRL_REG_A = (OWI_UART_2X << OWI_U2X);								// W܂͔{I
  OWI_UART_STATCTRL_REG_B = (1 << OWI_RXEN) | (1 << OWI_TXEN) | (1 << OWI_RXCIE);	// M,M,M荞݋
  // (ȉUCSRCݒ޲̏lƓȂ̂ō폜邱Ƃł܂B)
#ifdef URSEL	// pzuŁA
  OWI_UART_STATCTRL_REG_C = (1 << OWI_URSEL) | (1 << OWI_UCSZ1) | (1 << OWI_UCSZ0);	// UCSRCڼ޽I,8ޯ ް,èȂ,1~ޯĎw
#else			// ʔzuŁA
  OWI_UART_STATCTRL_REG_C = (1 << OWI_UCSZ1) | (1 << OWI_UCSZ0);					// 8ޯ ް,èȂ,1~ޯĎw
#endif
  OWIStatus.allFlags = FALSE;														// 1-WireS׸ޏ()
}

/*! \brief 1-Wire޽łؾĐMoƏ]ȗݐMM
 *
 * ̊֐UARTؾĐM̑MpɌ`Ԑݒ肵܂B1-Wireײނؾ/
 * ݎ菇܂ŁAZ׸ނ^łBZ׸ނUɂȂƁA׸ނ͑
 * MMꂽۂ܂B
 */
void OWI_DetectPresence(void)
{
  OWIStatus.busy = TRUE;						// Z׸ސݒ
  OWI_UART_BAUD_RATE_REG_L = OWI_UBRR_9600;		// ؾ/ݐMpްڰĂ9600bpsݒ
  OWI_UART_STATCTRL_REG_B |= (1 << OWI_UDRIE);	// UARTMJn̂߂UARTް ڼ޽󊄂荞݋
}

/*! \brief 1-Wire޽ްM
 *
 * ̊֐UARTްMpɌ`Ԑݒ肵܂BM܂őZ׸ނ
 * ^łB
 *
 *  \param  data		Mׂްւ߲
 *  
 *  \param  dataLength	MׂޯĐ
 */
void OWI_TransmitData(unsigned char * data, unsigned char dataLength)
{
  OWIStatus.busy = TRUE;						// Z׸ސݒ
  OWIDataBuffer = data;							// Mޯ̧߲ݒ
  OWIBufferLength = dataLength;					// Mޯ̧ް ޯĐݒ
  OWI_UART_STATCTRL_REG_B |= (1 << OWI_UDRIE);	// UARTMJn̂߂UARTް ڼ޽󊄂荞݋
}

/*! \brief 1-Wire޽ްM
 *
 * ̊֐UARTްMpɌ`Ԑݒ肵܂BM܂őZ׸ނ
 * ^łB
 *
 *  \param  data		Mްuׂ؈ʒuւ߲
 *
 *  \param  dataLength	MׂޯĐ
 */
void OWI_ReceiveData(unsigned char * data, unsigned char dataLength)
{
  unsigned char numBytes;

  numBytes = dataLength >> 3;			// ް ޲Đ擾
  if (dataLength & 0x07)				// ]ޯėLŁA
  {
	numBytes++;							// ް ޲Đ␳
  }
  while(numBytes)						// ޲Đޯ̧S1lݒ(ǂݍݐM1ݐMƓ̂)
  {
	data[numBytes - 1] = 0xFF;			// ޯ̧Ή޲=$FF
	numBytes--;							// ޲Čv팸
  }
  OWI_TransmitData(data, dataLength);	// KvޯĐ1M(ʂƂĎM)
}

/*! \brief UARTM荞ݏٰ
 *
 * ISR1-Wire޽̐M̎MƉ߂܂B
 */
#pragma vector = OWI_UART_RXC_VECT
__interrupt void UART_RXC_ISR()
{
  static unsigned char bitsReceived = 0;
  static unsigned char receiveBuffer = 0;
  static unsigned char byteIndex = 0;
  unsigned char waveform;

  if (OWI_UART_STATCTRL_REG_A & (1 << OWI_FE))		// UARTڰݸތŁA
  {
	waveform = OWI_UART_DATA_REGISTER;				// FERXC׸ނ邽߂UDRǂݍ
	OWIStatus.error = TRUE;							// ُ׸ސݒ
	OWIStatus.busy = FALSE;							// Z׸މ
	OWI_UART_STATCTRL_REG_B &= ~(1 << OWI_UDRIE);	// UARTް ڼ޽󂫊荞݋֎~(M~)
	return;
  }
  waveform = OWI_UART_DATA_REGISTER;				// UARTMl擾
  if (OWI_UART_BAUD_RATE_REG_L == OWI_UBRR_9600)	// 9600bps(ؾ/ݎ菇)ŁA
  {
	OWIStatus.presenceDetected = (waveform != OWI_UART_RESET);	// ׸ލXV(ݐMML)
	OWI_UART_BAUD_RATE_REG_L = OWI_UBRR_115200;		// ްڰĂ115200bpsɕύX
	bitsReceived = 0;								// MޯČv평()
	OWIStatus.busy = FALSE;							// Z׸މ
  }
  else												// 9600bpsȊO(ؾ/ݎ菇ȊO)ŁA
  {
	bitsReceived++;									// MޯČvis
	receiveBuffer >>= 1;							// Mꎞޯ̧E1ޯĈړ,0MSB
	if (waveform == OWI_UART_READ_BIT)				// 1ǂݍ݂ŁA
	{
	  receiveBuffer |= 0x80;						// Ήޯ(MSB)1ݒ
	}
	else											// 0ǂݍ݂ŁA
	{
													// ĂɂĊMSB=0̂߁AȂ
	}
	if (bitsReceived == OWIBufferLength)			// ŏIޯĂŁA
	{
	  while(bitsReceived++ & 0x07)					// ޯĈʒu{ʒuֈړ
	  {
		receiveBuffer >>= 1;						// Mꎞޯ̧E1ޯĈړ
	  }
	  OWIDataBuffer[byteIndex] = receiveBuffer;		// Mޯ̧Ή޲Ēli[
	  bitsReceived = 0;								// MޯĐv평
	  byteIndex = 0;								// Mޯ̧޲Ĉʒuwq
	  OWIStatus.busy = FALSE;						// Z׸މ
	}
	else											// ŏIޯĂłȂ΁A
	{
	  if (!(bitsReceived & 0x07))					// ޲ċEŁA
	  {
		OWIDataBuffer[byteIndex] = receiveBuffer;	// Mޯ̧Ή޲Ēli[
		byteIndex++;								// Mޯ̧޲Ĉʒuwqis
	  }
	}
  }    
  return;
}

/*! \brief UARTް ڼ޽󊄂荞ݏٰ
 *
 * ISRUART̑Mޯ̧̎ɓA]đMޯĂ̏
 * B
 */
#pragma vector = OWI_UART_UDRE_VECT
__interrupt void UART_UDRE_ISR()
{
  static unsigned char bitsSent = 0;
  static unsigned char transmitBuffer;
  static unsigned char byteIndex = 0;

  if (OWI_UART_BAUD_RATE_REG_L == OWI_UBRR_9600)	// 9600bps(ؾ/ݎ菇)ŁA
  {
	OWI_UART_DATA_REGISTER = OWI_UART_RESET;		// UDRؾĐMlݒ
	bitsSent = 0;									// MޯČv평
	OWI_UART_STATCTRL_REG_B &= ~(1 << OWI_UDRIE);	// UARTް ڼ޽󊄂荞݋֎~
	return;
  }
  if (bitsSent == 0)								// MޯĐ=0(ޯ)ŁA
  {
	byteIndex = 0;									// Mޯ̧޲Ĉʒuwq
	transmitBuffer = OWIDataBuffer[0];				// Mޯ̧擪瑗Mꎞޯ̧֑M޲Ēl擾
  }
  if (bitsSent == OWIBufferLength)					// ŏIޯĂŁA
  {
	bitsSent = 0;									// MޯČv평
	OWI_UART_STATCTRL_REG_B &= ~(1 << OWI_UDRIE);	// UARTް ڼ޽󊄂荞݋֎~
  }
  else												// ŏIޯĂłȂ΁A
  {
	if (transmitBuffer & 0x01)						// MޯĒl=1ŁA
	{
	  OWI_UART_DATA_REGISTER = OWI_UART_WRITE1;		// UDR1ݒlݒ
	}
	else											// MޯĒl=0ŁA
	{
	  OWI_UART_DATA_REGISTER = OWI_UART_WRITE0;		// UDR0ݒlݒ
	}
	transmitBuffer >>= 1;							// Mꎞޯ̧E1ޯĈړ
	bitsSent++;										// MޯČvis
	if (!(bitsSent & 0x07))							// ޲ċEŁA
	{
	  byteIndex++;									// Mޯ̧ʒuwqis
	  transmitBuffer = OWIDataBuffer[byteIndex];	// Mޯ̧瑗Mꎞޯ̧֑ΉM޲Ēl擾
	}
  }
  return;
}
