// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* \li ̧			: OWIHighLevelFunctions.c
* \li ߲		: IAR EWAAVR 3.20a
* \li xҰ		: avr@atmel.com
*
* \li x޲	: SAVR
*
* \li pLq		: AVR318 - Dallas 1-Wire(R)呕u
*
* \li 			: 1-Wire(R)޽ł̑S޲đMROM@\ߎsp̍ʊ֐
*
*                         $Revision: 1.7 $
*                         $Date: Thursday, August 19, 2004 14:27:18 UTC $
****************************************************************************/

#include <ioavr.h>

#include "OWIHighLevelFunctions.h"
#include "OWIBitFunctions.h"
#include "OWIPolled.h"

/*! \brief 1-Wire(R)޽1޲Ăް𑗐M
 *
 * ̊֐1-Wire޽ɊS޲ ް𑗐MƂ܂B
 *
 *  \param  data	޽ɑMް
 *  
 *  \param  pins	ް𑗐M޽ޯĎՕl
 */
void OWI_SendByte(unsigned char data, unsigned char pins)
{
  unsigned char temp;
  unsigned char i;

  for (i = 0; i < 8; i++)		// 1޲(8ޯ)M
  {
	temp = data & 0x01;			// ΉޯĒlo
	if (temp)					// Ήޯ=1ŁA
	{
	  OWI_WriteBit1(pins);		// 1ޯđM
	}
	else						// Ήޯ=0ŁA
	{
	  OWI_WriteBit0(pins);		// 0ޯđM
	}
	data >>= 1;					// MlE1ޯĈړ
  }
}

/*! \brief 1-Wire(R)޽1޲ĎM
 *
 * ̊֐1-Wire޽犮S1޲ ް̎M܂B
 *
 *  \param  pin	ǂݍ޽ޯĎՕl
 *  
 *  \return		޽ǂ܂ꂽ޲Ēl
 */
unsigned char OWI_ReceiveByte(unsigned char pin)
{
  unsigned char data;
  unsigned char i;

  data = 0x00;					// Mlϐ
  for (i = 0; i < 8; i++)		// 1޲(8ޯ)M
  {
	data >>= 1;					// MlϐE1ޯĈړ,0MSB
	if (OWI_ReadBit(pin))		// ǂݍݐMo/ǂݍ=1ŁA
	{
	  data |= 0x80;				// MlϐMSB=1
	}
  }
  return data;					// M޲ĒlƋɕA
}

/*! \brief 1-WireSKIP ROMߑo
 *
 *  \param  pins	SKIP ROM߂𑗏o޽ޯĎՕl
 */
void OWI_SkipRom(unsigned char pins)
{
  OWI_SendByte(OWI_ROM_SKIP, pins);		// SKIP ROMߑM
}

/*! \brief READ ROMߑoROMʎqǂݖ߂
 *
 *  \param  romValue	ʎqzuꏊւ߲
 *
 *  \param  pin			ǂݍ޽̎Օl
 */
void OWI_ReadRom(unsigned char * romValue, unsigned char pin)
{
  unsigned char bytesLeft = 8;

  OWI_SendByte(OWI_ROM_READ, pin);		// READ ROMߑM
  while (bytesLeft > 0)					// 64ޯ(8޲)M
  {
	*romValue++ = OWI_ReceiveByte(pin);	// ΉM޲Ăwʒu,߲is
	bytesLeft--;						// ޲Čv팸
  }
}

/*! \brief MATCH ROM߂Ǝw莯ʎqo
 *
 *  \param  romValue	w莯ʎqւ߲
 *
 *  \param  pins		MATCH ROM߂s޽̎Օl
 */
void OWI_MatchRom(unsigned char * romValue, unsigned char pins)
{
  unsigned char bytesLeft = 8;   

  OWI_SendByte(OWI_ROM_MATCH, pins);	// MATCH ROMߑM
  while (bytesLeft > 0)					// 64ޯĎʎq(8޲)M
  {
	OWI_SendByte(*romValue++, pins);	// w莯ʎqΉ޲đM,߲is
	bytesLeft--;						// ޲Čv팸
  }
}

/*! \brief SEARCH ROM߂𑗏o1-Wire(R)޽œ1̎ʎqԂ
 *
 *  \param  bitPattern		ʎqu8޲charzւ߲B
 *							̏]uɑ΂錟AŌɓꂽʎq
 *							zɒ񋟂ׂAȂΌ
 *							s܂B
 *
 *  \param  lastDeviation	ȎsɉĐisޯĈʒuB
 *							̈͌Jn0łׂłBJԂČ
 *							Ԏɂ̊֐̈ɕԂl邱ƂS
 *							]us܂B
 *
 *  \param  pin				ʎqs޽ޯĎՕl
 *
 *  \return					̊֐̒Osŏ]uڽԂŕsv
 *							IޯĈʒuB
 *							ُ팟o(ႦΌ̍Œɑuڑꂽ)OWI
 *							_ROM_SEARCH_FAILEDAׂuȂ
 *							OWI_ROM_SEARCH_FINISHEDԂ܂B
 *
 *  \note					̊֐̗p@ɂĂmain.cB
 */
unsigned char OWI_SearchRom(unsigned char * bitPattern, unsigned char lastDeviation, unsigned char pin)
{
  unsigned char currentBit = 1;
  unsigned char newDeviation = 0;
  unsigned char bitMask = 0x01;
  unsigned char bitA;
  unsigned char bitB;

  OWI_SendByte(OWI_ROM_SEARCH, pin);			// SEARCH ROMߑM
  while (currentBit <= 64)						// 64ޯĎʎq擾
  {
	bitA = OWI_ReadBit(pin);					// ΉޯĒlM
	bitB = OWI_ReadBit(pin);					// ΉޯĔ]lM
	if (bitA && bitB)							// '11'ŁA
	{
	  newDeviation = OWI_ROM_SEARCH_FAILED;		// sԂlݒ
	  return newDeviation;						// sƋɕA
	}
	else if (bitA ^ bitB)						// '01'܂'10'ŁA
	{
	  if (bitA)									// Ήޯ=1ŁA
	  {
		(*bitPattern) |= bitMask;				// MʎqΉޯ=1ݒ
	  }
	  else										// Ήޯ0ŁA
	  {
		(*bitPattern) &= ~bitMask;				// MʎqΉޯ=0ݒ
	  }
	}
	else										// '00'ŁA
	{
	  if (currentBit == lastDeviation)			// OƓޯĈʒuŁA
	  {
		(*bitPattern) |= bitMask;				// MʎqΉޯ=1ݒ(O0oς݂Ȃ̂)
	  }
	  else if (currentBit > lastDeviation)		// OޯĈʒuȍ~ŁA
	  {
		(*bitPattern) &= ~bitMask;				// MʎqΉޯ=0ݒ
		newDeviation = currentBit;				// ޯĈʒuԍXV
	  }
	  else if ( !(*bitPattern & bitMask))		// 0ς݂ŁA
	  {
		newDeviation = currentBit;				// ޯĈʒuԍXV
	  }
	  else										// 1ς݂ŁA
	  {
	  }
	}
	if ((*bitPattern) & bitMask)				// 񔻒ޯ=1ŁA
	{
	  OWI_WriteBit1(pin);						// FޯĂƂāA1ݐMM
	}
	else										// 񔻒ޯ=0ŁA
	{
	  OWI_WriteBit0(pin);						// FޯĂƂāA0ݐMM
	}
	currentBit++;								// ޯĔԍis
	bitMask <<= 1;								// ޯĎՕl1ޯĈړ
	if (!bitMask)								// 1޲ďIŁA
	{
	  bitMask = 0x01;							// ޲ēޯĎՕl擾
	  bitPattern++;								// Mʎq߲is
	}
  }
  return newDeviation;							// ޯĈʒuƋɕA
}

